package MT::Plugin::Replacer;
use strict;
use MT;
use MT::Plugin;

our $VERSION = '0.2';

use base qw( MT::Plugin );

@MT::Plugin::Replacer::ISA = qw( MT::Plugin );

my $plugin = __PACKAGE__->new( {
    id   => 'Replacer',
    key  => 'replacer',
    name => 'Replacer',
    author_name => 'Alfasado, Inc.',
    author_link => 'http://alfasado.net/',
    version => $VERSION,
    description => '<MT_TRANS phrase=\'_PLUGIN_DESCRIPTION\'>',
    settings => new MT::PluginSettings( [
        ['replacer_table', { Default => '' }],
        ['replacer_separator', { Default => ',' }],
    ] ),
    l10n_class => 'Replacer::L10N',
    blog_config_template => 'replacer_cfg.tmpl',
} );

MT->add_plugin( $plugin );

sub init_registry {
    my $plugin = shift;
    $plugin->registry( {
        tags => {
            modifier => {
                'replacer' => \&_fltr_replacer,
            },
        },
    } );
}

sub _fltr_replacer {
    my ( $text, $arg, $ctx ) = @_;
    my $blog = $ctx->stash( 'blog' );

    return $text unless defined $blog;

    my $table = $plugin->get_config_value( 'replacer_table', 'blog:'. $blog->id );
    my $separator = $plugin->get_config_value( 'replacer_separator', 'blog:'. $blog->id );
    $separator = quotemeta( $separator );
    $table =~ s/\r\n/\n/g;
    my @lines = split( /[\r\n]/, $table );
    for my $line ( @lines ) {
        my @item = split( /$separator/, $line );
        my $search  = $item[0];
        my $replace = $item[1];
        if ( $search ) {
            $search = quotemeta( $search );
            $text =~ s/$search/$replace/g;
        }
    }
    return $text;
}

1;