<?php
function smarty_modifier_replacer( $text ) {
    global $mt;
    $ctx =& $mt->context();
    $blog = $ctx->stash( 'blog' );
    if ( !isset( $blog ) ) {
        return $text;
    }
    $blog_id = $ctx->stash( 'blog_id' );
    $plugin_key = "blog:" . $blog_id;
    $plugin_data = $ctx->mt->db()->fetch_plugin_config( 'replacer', $plugin_key );
    $table     = $plugin_data['replacer_table'];
    $separator = $plugin_data['replacer_separator'];
    $lines = preg_split( "[\r\n]", $table );
    foreach ( $lines as $line ) {
        $item = explode( $separator, $line );
        $search  = $item[0];
        $replace = $item[1];
        if ( $search ) {
            $search  = preg_quote( $search, "/" );
            $replace = str_replace( "\\", "\\\\", $replace );
            $replace = str_replace( "$", "\$", $replace );
            $text    = preg_replace("/{$search}/", $replace, $text);
        }
    }
    return $text;
}